<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qtcreator-api.qdoc -->
  <title>Qt Creator API Reference | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Qt Creator API Reference</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#libraries">Libraries</a></li>
<li class="level2"><a href="#core-libraries">Core Libraries</a></li>
<li class="level2"><a href="#additional-libraries">Additional libraries</a></li>
<li class="level1"><a href="#plugins">Plugins</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Qt Creator API Reference</h1>
<span class="subtitle"></span>
<!-- $$$qtcreator-api.html-description -->
<div class="descr"> <a name="details"></a>
<p>The core of Qt Creator is basically only a <a href="extensionsystem.html">plugin loader</a>. All functionality is implemented in plugins. The basis of Qt Creator is implemented in the <a href="core.html">Core</a> Plugin. The plugin manager provides simple means for plugin cooperation that allow plugins to provide hooks for other plugin's extensions.</p>
<a name="libraries"></a>
<h2 id="libraries">Libraries</h2>
<a name="core-libraries"></a>
<h3 id="core-libraries">Core Libraries</h3>
<p>There are a few core libraries used by many parts of Qt Creator.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Library Name</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td ><a href="aggregation.html">Aggregation</a></td><td >Adds functionality for &quot;glueing&quot; QObjects of different types together, so you can &quot;cast&quot; between them.</td></tr>
<tr valign="top" class="even"><td ><a href="extensionsystem.html">ExtensionSystem</a></td><td >Implements the plugin loader framework. Provides a base class for plugins and basic mechanisms for plugin interaction like an object pool.</td></tr>
<tr valign="top" class="odd"><td ><a href="utils.html">Utils</a></td><td >General utility library.</td></tr>
<tr valign="top" class="even"><td ><a href="qmljs.html">QmlJS</a></td><td >QML and JavaScript language support library.</td></tr>
</table></div>
<a name="additional-libraries"></a>
<h3 id="additional-libraries">Additional libraries</h3>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Library Name</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td ><a href="qtcreatorcdbext.html">qtcreatorcdbext</a></td><td >Windows CDB debugger extension</td></tr>
</table></div>
<a name="plugins"></a>
<h2 id="plugins">Plugins</h2>
<p>As already mentioned, Qt Creator is basically only a plugin loader framework which gets its IDE functionality through plugins. The most important plugin is the <code>Core</code> plugin which provides all the basic functionality needed later to integrate e.g&#x2e; editors or mode windows.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Plugin Name</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td ><a href="core.html">Core</a></td><td >The core plugin. Provides the main window and managers for editors, actions, mode windows and files, just to mention the most important ones.<p>This plugin also contains classes necessary to hook into the Locator as well as support for searching text in arbitrary widgets.</p>
</td></tr>
<tr valign="top" class="even"><td ><a href="projectexplorer.html">ProjectExplorer</a></td><td >The project explorer plugin. Provides base classes for project handling.</td></tr>
<tr valign="top" class="odd"><td ><a href="debugger.html">Debugger</a></td><td >Debugging functionality.</td></tr>
<tr valign="top" class="even"><td ><a href="vcsbase.html">VcsBase</a></td><td >Base classes for version control support.</td></tr>
<tr valign="top" class="odd"><td ><a href="texteditor.html">TextEditor</a></td><td >This is where everything starts if you want to create a text editor. Besides the base editor itself, this plugin contains APIs for supporting functionality like <a href="extending-index.html#snippets">snippets</a>, highlighting, <a href="codeassist.html">code assist</a>, indentation and style, and others.</td></tr>
</table></div>
</div>
<!-- @@@qtcreator-api.html -->
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
